<?php
defined('_JEXEC') or die;

class plgSystemMlife_wm_sendsms extends JPlugin
{

public function __construct(&$subject, $config)
{
	parent::__construct($subject, $config);
	$adminforma = false;
	$user = & JFactory::getUser();

if($user->authorize( 'com_virtuemart', 'edit')==1) {
$adminforma = true;
}
	
	if($adminforma and JRequest::getVar('option')=='com_virtuemart' and JRequest::getVar('view')=='orders' and JRequest::getVar('virtuemart_order_id')>0) {

		$adminforma = true;
		
		$this->mlife_virtuemart_order_id = JRequest::getVar('virtuemart_order_id'); //ид заказа
		//получаем номер телефона для поля
		if(JRequest::getVar('mlife_phone')!=''){
		$this->mlife_phone = JRequest::getVar('mlife_phone');
		}
		else {
		$this->mlife_phone = $this->formatsmsc($this->phoneformat($this->userphone($this->mlife_virtuemart_order_id)));
		}
		
		//смотрим или чекбокс для отправки смс активен
		if(JRequest::getVar('mlife_sms_notified')==1) {
		//Если активен отправляем смс
		$this->mlife_send_sms($this->mlife_phone,$this->params->get('post_user','Статус заказа №#orderid# - #status#. #message#'));
		}
		if($this->params->get('phonemanagerlist',0)!=0){
			if(JRequest::getVar('mlife_sms_notified_manager')==1) {
				$this->mlife_send_sms($this->params->get('phonemanager'),$this->params->get('post_manager','Статус заказа №#orderid# - #status#. #message#'));
			}
		}else{
		$man = ' style="display:none"';
		}

	//добавляем js скрипт (добавление полей в форму)
	$document = JFactory::getDocument();
	$jsVars = '
	jQuery( function($) {
	var htmlupdate = \'<table class="admintable" width="100%"><tbody><tr><td style="width:120px;">Уведомлять по смс</td><td style="width:100px;">\';
	htmlupdate += \'<input type="hidden" name="mlife_sms_notified" value="0">\';
	htmlupdate += \'<input id="customer_notified" type="checkbox" name="mlife_sms_notified" value="1" checked="checked">\';
	htmlupdate += \'</td><td style="width:120px;"><font'.$man.'>Уведомлять менеджеров</font></td><td style="width:100px;"><input type="hidden" name="mlife_sms_notified_manager" value="0"><input'.$man.' id="customer_notified" type="checkbox" name="mlife_sms_notified_manager" value="1"></td></tr>\';
	htmlupdate += \'<tr><td style="width:120px;">Номер телефона<br/><font style="color:red">+79213334455</font></td><td style="width:100px;"><input style="width:90px;" type="text" name="mlife_phone" value="'.$this->mlife_phone.'"/></td><td colspan="2"><font'.$man.'>'.$this->params->get('phonemanager').'</font></td></tr>\';
	htmlupdate += \'</tbody></table>\';
	$("#orderStatForm fieldset").prepend(htmlupdate);
	});
	';
	$document->addScriptDeclaration($jsVars);
	}

}
	
//тригер финальный этап оформления заказа
function plgVmConfirmedOrder($this2, $order) {
$phone_admin_neworder_list = $this->params->get('phone_admin_neworder_list',0);
$phone_user_neworder_list = $this->params->get('phone_user_neworder_list',0);
	
	if($phone_admin_neworder_list!=0){
	//отправляем сообщение админу о поступлении заказа
	$post_admin_neworder = $this->params->get('post_admin_neworder','Поступил новый заказ №#orderid#, от #name# тел - #shoperphone#.');
	
	$orderid = $this2->order_number; //номер заказа
	$name = $this2->BT['first_name'].' '.$this2->BT['last_name']; //имя клиента
	$post_admin_neworder = str_replace('#orderid#',$orderid,$post_admin_neworder);
	$post_admin_neworder = str_replace('#name#',$name,$post_admin_neworder);
	$post_admin_neworder = str_replace('#shoperphone#',$this2->BT[$this->params->get('phone_user_field_code','phone_1')],$post_admin_neworder);
	
	$phone_admin_neworder = $this->params->get('phone_admin_neworder',false);
	$this->mlife_send_sms($phone_admin_neworder,$post_admin_neworder);
	}
	
	if($phone_user_neworder_list!=0){
	$fieldcode = $this->params->get('phone_user_field_code','phone_1');
		foreach ($order['details'] as $ordernew){
			$userphone = $ordernew->$fieldcode;
			if($userphone) 	break;
		}
	
	//отправляем сообщение пользователю о поступлении заказа
	$post_user_neworder = $this->params->get('post_user_neworder','#name#, Заказ №#orderid# принят. Секретный ключ для отслеживания заказа - #orderpass#');
	$orderid = $this2->order_number; //номер заказа
	$name = $this2->BT['first_name'].' '.$this2->BT['last_name']; //имя клиента
	$post_user_neworder = str_replace('#orderid#',$orderid,$post_user_neworder);
	$post_user_neworder = str_replace('#name#',$name,$post_user_neworder);
	$post_user_neworder = str_replace('#orderpass#',$this->get_order_pass($orderid),$post_user_neworder);
	
	$userphone = $this->formatsmsc($this->phoneformat($userphone));
	
	$this->mlife_send_sms($userphone,$post_user_neworder);
	
	}
	
}
	
function userphone($virtuemart_order_id) {
	$db = JFactory::getDBO();
	$sql = "SELECT ".$this->params->get('phone_user_field_code','phone_1')." FROM #__virtuemart_order_userinfos WHERE virtuemart_order_id=".$virtuemart_order_id;
	$db->setQuery($sql);
	$phone = $db->loadResult();
	return $phone;
}

function get_order_pass($order_number) {
	$db = JFactory::getDBO();
	$sql = "SELECT order_pass FROM #__virtuemart_orders WHERE order_number='".$order_number."'";
	$db->setQuery($sql);
	$orderpass = $db->loadResult();
	return $orderpass;
}
	
function get_order_status_name($code) {
$db = JFactory::getDBO();
$sql = "SELECT order_status_name FROM #__virtuemart_orderstates WHERE order_status_code='".$code."'";
$db->setQuery($sql);
return $db->loadResult();
}
	
function mlife_send_sms($phone,$shab) {
if(JRequest::getVar('order_status',0)!=0){
	$orderstatus = $this->get_order_status_name(JRequest::getVar('order_status'));
	$shab = str_replace("#orderid#", $this->mlife_virtuemart_order_id, $shab);
	$shab = str_replace("#status#", $orderstatus, $shab);
	if(JRequest::getVar('include_comment')==1) {
	$shab = str_replace("#message#", JRequest::getVar('comments'), $shab);
	}
	else{
	$shab = str_replace("#message#", '', $shab);
	}
}
	
$massage = $shab;
	
$arsend['phone']=$phone;
$arsend['massage']=$massage;
$arsend['senderid']= $this->params->get('smscab_senderid');
$this->send_sms($arsend['phone'],$arsend['massage'],$arsend['senderid']); //отправляем сообщение
}




////////////////////////////////////////////////////////////////smscab

// Функция отправки SMS
function send_sms($phones, $message, $sender = false, $translit = 0, $time = 0, $id = 0, $format = 0, $query = "")
{

if($this->params->get('smscab_variant',1)==2){
$this->sms_sending_send_sms($phones, $message);
return;
}

	if($phones){
	$config = $this->getcfg();
	    static $formats = array(1 => "flash=1", "push=1", "hlr=1", "bin=1", "bin=2", "ping=1");

	    $m = $this->_smsc_send_cmd("send", "cost=3&phones=".urlencode($phones)."&mes=".urlencode($message).
			    "&translit=".$config['SMSCAB_TRANSLIT']."&id=$id".($format > 0 ? "&".$formats[$format] : "").
			    ($sender === false ? "" : "&sender=".urlencode($sender))."&charset=".$config['SMSCAB_CHARSET'].
			    ($time ? "&time=".urlencode($time) : "").($query ? "&$query" : ""));

	    return $m;
	}
	else{
	return;
	}
}

// Функция получения баланса
// возвращает баланс в виде строки или false в случае ошибки
function get_balance()
{
    $m = $this->_smsc_send_cmd("balance"); // (balance) или (0, -error)

    return isset($m[1]) ? false : $m[0];
}


// ВНУТРЕННИЕ ФУНКЦИИ smscab
// Функция вызова запроса. Формирует URL и делает 3 попытки чтения
function _smsc_send_cmd($cmd, $arg = "")
{
$config = $this->getcfg();
    $url = "http://my.smscab.ru/sys/$cmd.php?login=".urlencode($config['SMSCAB_LOGIN'])."&psw=".urlencode($config['SMSCAB_PASSWORD'])."&fmt=1&".$arg;
    $i = 0;
    do {
        if ($i)
            sleep(2);

        $ret = $this->_smsc_read_url($url);
    }
    while ($ret == "" && ++$i < 3);
    return explode(",", $ret);
}

// Функция чтения URL. Для работы должно быть доступно:
// curl или fsockopen (только http) или включена опция allow_url_fopen для file_get_contents
function _smsc_read_url($url)
{
    $ret = "";
    $post = 1 ;//|| strlen($url) > 2000;

    if (function_exists("curl_init"))
    {
        static $c = 0; // keepalive

        if (!$c) {
            $c = curl_init();
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($c, CURLOPT_TIMEOUT, 60);
            curl_setopt($c, CURLOPT_SSL_VERIFYPEER, 0);
        }

        if ($post) {
            list($url, $post) = explode('?', $url, 2);
            curl_setopt($c, CURLOPT_POST, true);
            curl_setopt($c, CURLOPT_POSTFIELDS, $post);
        }

        curl_setopt($c, CURLOPT_URL, $url);

        $ret = curl_exec($c);
    }
    elseif (function_exists("fsockopen"))
    {
        $m = parse_url($url);

        $fp = fsockopen($m["host"], 80, $errno, $errstr, 10);

        if ($fp) {
            fwrite($fp, ($post ? "POST $m[path]" : "GET $m[path]?$m[query]")." HTTP/1.1\r\nHost: my.smscab.ru\r\nUser-Agent: PHP".($post ? "\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: ".strlen($m['query']) : "")."\r\nConnection: Close\r\n\r\n".($post ? $m['query'] : ""));

            while (!feof($fp))
                $ret .= fgets($fp, 1024);
            list(, $ret) = explode("\r\n\r\n", $ret, 2);

            fclose($fp);
        }
    }
    else
        $ret = file_get_contents($url);

    return $ret;
}

////////////////////////////////////////////////////////////////endsmsc


function phoneformat($phone = '', $convert = true, $trim = true) 
{

//$phoneCodes - параметры кодов стран
$phoneCodes = Array(
'7'=>Array(
         'name'=>'Россия', // для удобства. Не будет использоваться. 
         'cityCodeLength'=> 3, //длинна кодов оператора
         'exceptions'=>Array(), //коды операторов исключения
     ),
'375'=>Array(
         'name'=>'Беларусь', 
         'cityCodeLength'=> 2, 
         'exceptions'=>Array(), 
     ),
);
 
     if (empty($phone)) {
         return ''; 
     }
     
     // очистка от лишнего мусора с сохранением информации о "плюсе" в начале номера 
     $phone=trim($phone); 
     $plus = ($phone[ 0] == '+'); 
     $phone = preg_replace("/[^0-9A-Za-z]/", "", $phone);
     $OriginalPhone = $phone; 
   
     // конвертируем буквенный номер в цифровой 
     if ($convert == true && !is_numeric($phone)) {
         $replace = array('2'=>array('a','b','c'), 
         '3'=>array('d','e','f'), 
         '4'=>array('g','h','i'), 
         '5'=>array('j','k','l'), 
         '6'=>array('m','n','o'), 
         '7'=>array('p','q','r','s'), 
         '8'=>array('t','u','v'), 
         '9'=>array('w','x','y','z')); 
   
         foreach($replace as $digit=>$letters) { 
             $phone = str_ireplace($letters, $digit, $phone); 
         } 
     }
   
     // заменяем 00 в начале номера на + 
     if (substr($phone,  0, 2)=="00") 
     {
         $phone = substr($phone, 2, strlen($phone)-2); 
         $plus=true; 
     }
   
     // если телефон длиннее 7 символов, начинаем поиск страны 
     if (strlen($phone)>7) 
     foreach ($phoneCodes as $countryCode=>$data) 
     {
         $codeLen = strlen($countryCode); 
         if (substr($phone,  0, $codeLen)==$countryCode) 
         { 
             // как только страна обнаружена, урезаем телефон до уровня кода города 
             $phone = substr($phone, $codeLen, strlen($phone)-$codeLen); 
             $zero=false; 
             // проверяем на наличие нулей в коде города 
             if ($data['zeroHack'] && $phone[ 0]=='0') 
             { 
                 $zero=true; 
                 $phone = substr($phone, 1, strlen($phone)-1); 
             } 
   
             $cityCode=NULL; 
             // сначала сравниваем с городами-исключениями 
             if ($data['exceptions_max']!= 0) 
             for ($cityCodeLen=$data['exceptions_max']; $cityCodeLen>=$data['exceptions_min']; $cityCodeLen--) 
             if (in_array(intval(substr($phone,  0, $cityCodeLen)), $data['exceptions'])) 
             { 
                 $cityCode = ($zero ? "0" : "").substr($phone,  0, $cityCodeLen); 
                 $phone = substr($phone, $cityCodeLen, strlen($phone)-$cityCodeLen); 
                 break; 
             } 
             // в случае неудачи с исключениями вырезаем код города в соответствии с длиной по умолчанию 
             if (is_null($cityCode)) 
             { 
                 $cityCode = substr($phone,  0, $data['cityCodeLength']); 
                 $phone = substr($phone, $data['cityCodeLength'], strlen($phone)-$data['cityCodeLength']); 
             } 
             // возвращаем результат 
             return ($plus ? "+" : "+").$countryCode.'('.$cityCode.')'.$this->phoneBlocks($phone); 
         } 
     }
     // возвращаем результат без кода страны и города 
     return ($plus ? "+" : "").$this->phoneBlocks($phone); 
}
   
// функция превращает любое число в строку формата XX-XX-... или XXX-XX-XX-... в зависимости от четности кол-ва цифр
function phoneBlocks($number){
     $add=''; 
     if (strlen($number)%2) 
     {
         $add = $number[ 0]; 
         $add .= (strlen($number)<=5 ? "-" : ""); 
         $number = substr($number, 1, strlen($number)-1); 
     } 
     return $add.implode("-", str_split($number, 2)); 
}

// очистка от лишнего мусора номера с сохранением информации о "плюсе" в начале номера 
function formatsmsc ($phone) {
     $phone=trim($phone); 
     $plus = ($phone[ 0] == '+'); 
     $phone = preg_replace("/[^0-9A-Za-z]/", "", $phone);
     
     if(substr($phone,  0, 2)=='80') {
     $phone = $this->params->get('phone_user_neworder_code','7').substr($phone,2,50);
     }
     
     if(substr($phone,  0, 1)=='8') {
     $phone = $this->params->get('phone_user_neworder_code','7').substr($phone,1,50);
     }
	 
	 if(strlen($phone)==10){
	 $phone = $this->params->get('phone_user_neworder_code','7').$phone;
	 }
     
     return '+'.$phone;
}

//получение конфига и данных для smscab
function getcfg() {
$configar['SMSCAB_LOGIN'] = $this->params->get('smscab_login');
$configar['SMSCAB_PASSWORD'] = $this->params->get('smscab_pass');
$configar['SMSCAB_CHARSET'] = $this->params->get('smscab_charset');
$configar['SMSCAB_SENDERID'] = $this->params->get('smscab_senderid');
$configar['SMSCAB_TRANSLIT'] = $this->params->get('smscab_translit');
return $configar;
}
	

}